module StatisticalMethods
  # Calculation class
  class Computer
    def initialize
      @average = StatisticalMethods::SummaryStatistic::Location::Average
      @median = StatisticalMethods::SummaryStatistic::Location::Median
      @mode = StatisticalMethods::SummaryStatistic::Location::Mode
    end

    def sum(array)
      array.addition
    end

    def mean(array)
      @average.new(array).arithmetic_mean
    end

    def min(array)
      array.min
    end

    def max(array)
      array.max
    end

    # http://en.wikipedia.org/wiki/Variance
    def variance(array)
      arithmetic_mean = mean(array)
      mean(array.map { |value| (arithmetic_mean - value)**2 })
    end

    # http://en.wikipedia.org/wiki/Standard_deviation
    def standard_deviation(array)
      Math.sqrt(variance array)
    end

    # http://en.wikipedia.org/wiki/Median
    def median(array)
      @median.new(array).find
    end

    def harmonic_mean(array)
      @average.new(array).harmonic_mean
    end

    def geometric_mean(array)
      @average.new(array).geometric_mean
    end

    # http://en.wikipedia.org/wiki/Mode_(statistics)
    def mode(array)
      @mode.new(array).find
    end

    def quadratic_mean(array)
      @average.new(array).quadratic_mean
    end

    def power_mean(array, exponent)
      @average.new(array).power_mean(exponent)
    end

    def leader(array)
      Leader.new(array).find
    end
  end
end
