module StatisticalMethods
  module Core
    # Extending class
    module Array
      def addition
        reduce(:+)
      end

      def multiplication
        reduce(:*)
      end

      def power(exponent)
        map { |value| value**exponent }
      end

      def harmonic
        map { |value| 1.0 / value }
      end

      def group_by_count
        reduce(Hash.new(0)) do |hash, item|
          hash[item] += 1
          hash
        end
      end
    end

    # Core class Array
    class ::Array
      include StatisticalMethods::Core::Array
    end
  end
end
