module StatisticalMethods
  # Finding a leader in the collection
  class Leader
    def initialize(array)
      @array = array
      @candidate = array.first
      @counter = 0
    end

    def find
      @array.each { |value| compare(value) }
      @candidate if @array.count(@candidate) > @array.size / 2
    end

    private

    def compare(value)
      @candidate == value ? increment : decrement(value)
    end

    def increment
      @counter += 1
    end

    def decrement(value)
      @counter -= 1
      return if @counter == 0
      @candidate = value
      @counter = 1
    end
  end
end
